org.apache.cassandra.cql3

## Interface ColumnNameBuilder

All Known Implementing Classes:
  CompositeType.Builder

    public interface ColumnNameBuilder

Build a potentially composite column name.

### Method Summary

Methods
`ColumnNameBuilder` `add(java.nio.ByteBuffer bb)` Add a new ByteBuffer as the next component for this name.
`java.nio.ByteBuffer` `build()` Build the column name.
`java.nio.ByteBuffer` `buildAsEndOfRange()` Build the column name so that the result sorts at the end of the range represented by this (uncomplete) column name.
`java.nio.ByteBuffer` `buildForRelation(Relation.Type op)`
`int` `componentCount()` Returns the number of component already added to this builder.
`ColumnNameBuilder` `copy()` Clone this builder.
`java.nio.ByteBuffer` `get(int idx)`
`java.nio.ByteBuffer` `getComponent(int i)` Returns the ith component added to this builder.
`int` `remainingCount()`

### Method Detail

#### add

    ColumnNameBuilder add(java.nio.ByteBuffer bb)

Add a new ByteBuffer as the next component for this name.

Parameters:
  `bb` - the ByteBuffer to add
Returns:
  this builder
Throws:
  `java.lang.IllegalStateException` - if the builder if full, i.e. if enough component has been added.

#### componentCount

    int componentCount()

Returns the number of component already added to this builder.

Returns:
  the number of component in this Builder

#### remainingCount

    int remainingCount()

Returns:
  the maximum number of component that can still be added to this Builder

#### get

    java.nio.ByteBuffer get(int idx)

Returns:
  the ith component in this builder.

#### build

    java.nio.ByteBuffer build()

Build the column name.

Returns:
  the built column name

#### buildAsEndOfRange

    java.nio.ByteBuffer buildAsEndOfRange()

Build the column name so that the result sorts at the end of the range represented by this (uncomplete) column name.

Throws:
  `java.lang.IllegalStateException` - if the builder is empty or full.

#### buildForRelation

    java.nio.ByteBuffer buildForRelation(Relation.Type op)

#### copy

    ColumnNameBuilder copy()

Clone this builder.

Returns:
  the cloned builder.

#### getComponent

    java.nio.ByteBuffer getComponent(int i)

Returns the ith component added to this builder.

Parameters:
  `i` - the component to return
Returns:
  the ith component added to this builder.
Throws:
  `java.lang.IllegalArgumentException` - if i >= componentCount().